> For the complete documentation index, see [llms.txt](https://docs.yarnspinner.dev/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.yarnspinner.dev/2.2/api/csharp/yarn/yarn.library/yarn.library.registerfunction-5.md).

# RegisterFunction(string,Func\<T1, T2, T3, T4, TResult>)

Method in [Library](/2.2/api/csharp/yarn/yarn.library.md)

## Summary

Registers a new function that returns a value, which can be called from a Yarn program.

```csharp
public void RegisterFunction<T1, T2, T3, T4, TResult>(string name, Func<T1, T2, T3, T4, TResult> implementation)
```

## Parameters

| Name                                                  | Description                                           |
| ----------------------------------------------------- | ----------------------------------------------------- |
| `string` name                                         | The name of the function.                             |
| `System.Func<T1, T2, T3, T4, TResult>` implementation | The method to be invoked when the function is called. |

## Type Parameters

| Name    | Description                                 |
| ------- | ------------------------------------------- |
| TResult | The return type of the function.            |
| TResult | The return type of the function.            |
| T1      | The type of the function's first argument.  |
| T2      | The type of the function's second argument. |
| T3      | The type of the function's third argument.  |
| T4      | The type of the function's fourth argument. |


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.yarnspinner.dev/2.2/api/csharp/yarn/yarn.library/yarn.library.registerfunction-5.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
